/*! @addtogroup GPIO General Purpose Input/Output
 *  @{
 *  @ingroup 	DEVICE_DRIVERS
 * 	@file		gpio.h
 *  @brief 		GPIO Header File.
 *  @}
 */
#ifndef GPIO_H_
#define GPIO_H_

#include "derivative.h"
#include "types.h"

/* GPIO - Peripheral instance base addresses */
/*! Peripheral GPIOA base pointer */
#define GPIOA                             ((GPIO_MemMapPtr)0x400FF000u)
/*! Peripheral GPIOB base pointer */
#define GPIOB                             ((GPIO_MemMapPtr)0x400FF040u)
/*! Peripheral GPIOC base pointer */
#define GPIOC                             ((GPIO_MemMapPtr)0x400FF080u)
/*! Peripheral GPIOD base pointer */
#define GPIOD                             ((GPIO_MemMapPtr)0x400FF0C0u)
/*! Peripheral GPIOE base pointer */
#define GPIOE                             ((GPIO_MemMapPtr)0x400FF100u)

#define PIN(x)	1<<x


/* Function Prototypes */
void pin_PutVal(GPIO_MemMapPtr gpio, uint8_t pin, bool val);
void pin_ClrVal(GPIO_MemMapPtr gpio, uint8_t pin);
void pin_SetVal(GPIO_MemMapPtr gpio, uint8_t pin);
void pin_NegVal(GPIO_MemMapPtr gpio, uint8_t pin);
bool pin_GetVal(GPIO_MemMapPtr gpio, uint8_t pin);
void port_PutVal(GPIO_MemMapPtr gpio, uint32_t val);
uint32_t port_GetVal(GPIO_MemMapPtr gpio);

#endif /* GPIO_H_ */
