
#include "lcd.h"

void lcd_init (void)
{
	systick_delay_ms(50);
	cmd_lcd(FS_8BIT_2L_5X7PX);
	systick_delay_ms(1);
	cmd_lcd(FS_8BIT_2L_5X7PX);
	systick_delay_ms(1);
	cmd_lcd(FS_8BIT_2L_5X7PX);
	cmd_lcd(FS_4BIT_2L_5X7PX);	// Function set (4-bit interface, 2 lines, 5*7Pixels)
	cmd_lcd(FS_4BIT_2L_5X7PX);	// Function set (4-bit interface, 2 lines, 5*7Pixels)
	cmd_lcd(DSPLY_ON_CRSR_OFF);	// Make cursor invisible
	cmd_lcd(CLR_DISPLAY);		// Clear screen
	cmd_lcd(ENTRY_MODE);		// Set entry Mode(auto increment of cursor)
	
}

void cmd_lcd(uint8_t c)
{
	pin_PutVal(RS, LOW);
	systick_delay_ms(1);
	data(c);
}

void data_lcd (uint8_t c)
{
	pin_PutVal(RS, HIGH);
	systick_delay_ms(1);
	data(c);
}

void data(unsigned char c)
{
    int temp;
    temp = port_GetVal(LCD);
    temp &= ~(LCD_PORT_MASK);
    temp |= LCD_PORT(c >> 4);
    port_PutVal(LCD, temp);
    lcd_strobe();
    temp &= ~(LCD_PORT_MASK);
    temp |= LCD_PORT(c);
    port_PutVal(LCD, temp);
    lcd_strobe();
}

void lcd_strobe (void)
{
	pin_PutVal(EN, HIGH);
	asm("NOP");
	pin_PutVal(EN, LOW);
}
