
#ifndef LCD_H_
#define LCD_H_

#include "types.h"
#include "derivative.h"
#include "gpio.h"
#include "systick.h"


#define LCD_PORT_MASK                0xFu
#define LCD_PORT_SHIFT               0
#define LCD_PORT(x)                  (((uint8_t)(((uint8_t)(x))<<LCD_PORT_SHIFT))&LCD_PORT_MASK)

#define LCD	GPIOB

#define RS 	GPIOA, 5
#define EN	GPIOA, 4

#define LOW		0
#define	HIGH	1

#define FS_8BIT_1L_5X7PX	0x30
#define FS_8BIT_2L_5X7PX	0x38
#define FS_4BIT_1L_5X7PX	0x20
#define FS_4BIT_2L_5X7PX	0x28

#define DSPLY_OFF_CRSR_OFF	0x08
#define DSPLY_ON_CRSR_ON	0x0E
#define DSPLY_ON_CRSR_OFF	0x0C
#define DSPLY_ON_CRSR_BLKNG	0x0F

#define ENTRY_MODE			0x06

#define FIRST_ROW			0x80
#define SECOND_ROW			0xC0	

#define SHIFT_ALL_LEFT		0x18
#define SHIFT_ALL_RIGHT		0x1C

#define MOV_1_CHAR_LEFT		0x10
#define MOV_1_CHAR_RIGHT	0x14

#define CLR_DISPLAY			0x01

void lcd_init (void);
void cmd_lcd(uint8_t c);
void data_lcd (uint8_t c);
void data(unsigned char c);
void lcd_strobe (void);

#endif /* LCD_H_ */
