/*! @addtogroup NVIC Nested Vector Interrupt Controller
 *  @{
 *  @ingroup 	DEVICE_DRIVERS
 * 	@file		nvic.h
 *  @brief 		NVIC Header File.
 *  @}
 */
#ifndef NVIC_H_
#define NVIC_H_

#include "derivative.h"

/*! ARM Cortex M0 implementation for interrupt priority shift */
#define ARM_INTERRUPT_LEVEL_BITS          2
/*! Enable Global Interrupts */
#define ENABLE_INTERRUPTS  asm(" CPSIE i")
/*! Disable Global Interrupts */
#define DISABLE_INTERRUPTS asm(" CPSID i")

void enable_irq (uint8_t);
void disable_irq (uint8_t);
void set_irq_priority (uint8_t, uint8_t);

#endif /* NVIC_H_ */
