/**
 * Freescale Semiconductor Inc.
 * (c) Copyright 2004-2010 Freescale Semiconductor, Inc.
 * ALL RIGHTS RESERVED.
 *
 **************************************************************************************************
 *
 * THIS SOFTWARE IS PROVIDED BY FREESCALE "AS IS" AND ANY EXPRESSED OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
 * IN NO EVENT SHALL FREESCALE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
 * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
 * THE POSSIBILITY OF SUCH DAMAGE.
 *
 **********************************************************************************************//*!
 * @mainpage  FRDM-KL25Z running at 48MHz
 *
 *            This project configures: 
 *            -The MCG to run from an external 8MHz crystal in PEE mode at 48MHz.
 *            -The UART0 as the Terminal Port, Baud Rate 115200.
 *            
 *            
 * @file Main.c
 *
 * @author Al Pia b34443 (support@freescale.com)
 *
 * @date   Oct-2013
 *
 * @brief 	This project configures: 
 *          - The MCG running from an external 8MHz XTAL in PEE mode at 48MHz.
 *          - The UART0 as the Terminal Port, Baud Rate 115200.
 *         
 */

#include "sysinit.h"
#include "io.h"
#include "mma8451.h"
#include "lcd.h"

int main(void)
{
	uint32_t counter = 0;
	sysinit(); /*System Initialization MCG,UART, alphanumeric LCD and Port Pins*/
	
	put_serial("\r\nHello World! FRDM-KL25Z...\r\n");
	
	put_lcd("Hello World!");
	cmd_lcd(SECOND_ROW);
	put_lcd("FRDM-KL25Z OK!");
	systick_delay_ms(2000);
	cmd_lcd(CLR_DISPLAY);
	
	while(TRUE)
	{
		accel_read();
		printf_serial("Counter = %d, X = %d, Y = %d, Z = %d\n\r",counter, resultx, resulty, resultz);
		counter++;
		systick_delay_ms(500);
	}
	
	return 0;
}
