/*! @file	freedom.h
 *  @brief Board Header File.
 *  @details This is the Board header file. 
 */
#ifndef FREEDOM_H_
#define FREEDOM_H_

#define FALSE	(0)
#define	TRUE	(1)

/*! Uses UART0 for Open SDA CDC*/
#define TERM_PORT_NUM    0

/*!Baud Rate serial port*/
#define TERMINAL_BAUD       115200

/*!UART working in polling mode*/
#define POLLING				0
/*!UART working in interrupt mode*/
#define INTERRUPT			1

/*!if TRUE PLL is initialized*/
#define PLL_INIT TRUE

/*! Input Clock Frequency */
#define CLK0_FREQ_HZ        8000000
/*! Input Clock Type */
#define CLK0_TYPE           CRYSTAL

/*!Divider reference by 4 = 2 MHz*/
#define PLL0_PRDIV      4
/*!Multiply reference by 24 = 48 MHz*/
#define PLL0_VDIV       24

/*!Configure crystal oscillator for low-power operation*/
#define LOW_POWER 0
/*!Configure crystal oscillator for high-gain operation*/
#define HIGH_GAIN 1

/*!External reference clock requested*/
#define CANNED_OSC  0
/*!Crystal oscillator requested*/
#define CRYSTAL 1

/*!FLL or PLL is selected as clock source for MCGOUTCLK(depends on PLLS control bit)*/
#define PLLS 0
/*!Internal Reference is selected as clock source for MCGOUTCLK(depends on PLLS control bit)*/
#define IREF 1
/*!External Reference is selected as clock source for MCGOUTCLK(depends on PLLS control bit)*/
#define EREF 2

#endif /* FREEDOM_H_ */
